import { WebDisplayDensityBaseDescription } from "./WebDisplayDensityBaseDescription";
import { WebDataCloneStrategyDescription } from "./WebDataCloneStrategyDescription";
import { WebGridClipboardOptionsDescription } from "./WebGridClipboardOptionsDescription";
import { WebActionStripDescription } from "./WebActionStripDescription";
import { WebPaginatorDescription } from "./WebPaginatorDescription";
import { WebGridResourceStringsDescription } from "./WebGridResourceStringsDescription";
import { WebFilteringExpressionsTreeDescription } from "./WebFilteringExpressionsTreeDescription";
import { Type } from "./type";
import { WebPinningConfigDescription } from "./WebPinningConfigDescription";
import { WebFilteringStrategyDescription } from "./WebFilteringStrategyDescription";
import { WebGridSortingStrategyDescription } from "./WebGridSortingStrategyDescription";
import { WebSortingOptionsDescription } from "./WebSortingOptionsDescription";
import { WebSortingExpressionDescription } from "./WebSortingExpressionDescription";
import { WebOverlayOutletDirectiveDescription } from "./WebOverlayOutletDirectiveDescription";
import { WebColumnDescription } from "./WebColumnDescription";
import { WebDisplayDensityBaseElementDescription } from "./WebDisplayDensityBaseElementDescription";
import { WebGridToolbarContentDescription } from "./WebGridToolbarContentDescription";
/**
 * @hidden
 */
export declare abstract class WebGridBaseDirectiveDescription extends WebDisplayDensityBaseDescription {
    static $t: Type;
    protected get_type(): string;
    constructor();
    private bq;
    get snackbarDisplayTime(): number;
    set snackbarDisplayTime(a: number);
    private aw;
    get autoGenerate(): boolean;
    set autoGenerate(a: boolean);
    private n;
    get autoGenerateExclude(): string[];
    set autoGenerateExclude(a: string[]);
    private a2;
    get moving(): boolean;
    set moving(a: boolean);
    private cy;
    get emptyGridTemplateRef(): string;
    set emptyGridTemplateRef(a: string);
    private b3;
    get addRowEmptyTemplateRef(): string;
    set addRowEmptyTemplateRef(a: string);
    private de;
    get loadingGridTemplateRef(): string;
    set loadingGridTemplateRef(a: string);
    private br;
    get summaryRowHeight(): number;
    set summaryRowHeight(a: number);
    private aa;
    get dataCloneStrategy(): WebDataCloneStrategyDescription;
    set dataCloneStrategy(a: WebDataCloneStrategyDescription);
    private ai;
    get clipboardOptions(): WebGridClipboardOptionsDescription;
    set clipboardOptions(a: WebGridClipboardOptionsDescription);
    private cz;
    get evenRowCSS(): string;
    set evenRowCSS(a: string);
    private dg;
    get oddRowCSS(): string;
    set oddRowCSS(a: string);
    private ds;
    get rowClassesRef(): string;
    set rowClassesRef(a: string);
    private ea;
    get rowStylesRef(): string;
    set rowStylesRef(a: string);
    private dl;
    get primaryKey(): string;
    set primaryKey(a: string);
    private y;
    get actionStrip(): WebActionStripDescription;
    set actionStrip(a: WebActionStripDescription);
    private cv;
    get emptyFilteredGridTemplateRef(): string;
    set emptyFilteredGridTemplateRef(a: string);
    private cw;
    get emptyGridDefaultTemplateRef(): string;
    set emptyGridDefaultTemplateRef(a: string);
    private cs;
    get dragGhostCustomTemplateRef(): string;
    set dragGhostCustomTemplateRef(a: string);
    private d3;
    get rowEditTextTemplateRef(): string;
    set rowEditTextTemplateRef(a: string);
    private dr;
    get rowAddTextTemplateRef(): string;
    set rowAddTextTemplateRef(a: string);
    private dz;
    get rowEditActionsTemplateRef(): string;
    set rowEditActionsTemplateRef(a: string);
    private d4;
    get rowExpandedIndicatorTemplateRef(): string;
    set rowExpandedIndicatorTemplateRef(a: string);
    private dt;
    get rowCollapsedIndicatorTemplateRef(): string;
    set rowCollapsedIndicatorTemplateRef(a: string);
    private dc;
    get headerExpandIndicatorTemplateRef(): string;
    set headerExpandIndicatorTemplateRef(a: string);
    private db;
    get headerCollapseIndicatorTemplateRef(): string;
    set headerCollapseIndicatorTemplateRef(a: string);
    private c0;
    get excelStyleHeaderIconDirectiveTemplateRef(): string;
    set excelStyleHeaderIconDirectiveTemplateRef(a: string);
    private c1;
    get excelStyleHeaderIconTemplateRef(): string;
    set excelStyleHeaderIconTemplateRef(a: string);
    private ee;
    get sortAscendingHeaderIconTemplateRef(): string;
    set sortAscendingHeaderIconTemplateRef(a: string);
    private ef;
    get sortDescendingHeaderIconDirectiveTemplateRef(): string;
    set sortDescendingHeaderIconDirectiveTemplateRef(a: string);
    private eg;
    get sortDescendingHeaderIconTemplateRef(): string;
    set sortDescendingHeaderIconTemplateRef(a: string);
    private eh;
    get sortHeaderIconTemplateRef(): string;
    set sortHeaderIconTemplateRef(a: string);
    private r;
    get toolbar(): WebGridToolbarDescription[];
    set toolbar(a: WebGridToolbarDescription[]);
    private p;
    get paginationComponents(): WebPaginatorDescription[];
    set paginationComponents(a: WebPaginatorDescription[]);
    private ak;
    get resourceStrings(): WebGridResourceStringsDescription;
    set resourceStrings(a: WebGridResourceStringsDescription);
    private c5;
    get filteringLogic(): string;
    set filteringLogic(a: string);
    private ad;
    get filteringExpressionsTree(): WebFilteringExpressionsTreeDescription;
    set filteringExpressionsTree(a: WebFilteringExpressionsTreeDescription);
    private ac;
    get advancedFilteringExpressionsTree(): WebFilteringExpressionsTreeDescription;
    set advancedFilteringExpressionsTree(a: WebFilteringExpressionsTreeDescription);
    private df;
    get locale(): string;
    set locale(a: string);
    private dj;
    get pagingMode(): string;
    set pagingMode(a: string);
    private a3;
    get paging(): boolean;
    set paging(a: boolean);
    private bo;
    get page(): number;
    set page(a: number);
    private bp;
    get perPage(): number;
    set perPage(a: number);
    private az;
    get hideRowSelectors(): boolean;
    set hideRowSelectors(a: boolean);
    private a4;
    get rowDraggable(): boolean;
    set rowDraggable(a: boolean);
    private ep;
    get validationTrigger(): string;
    set validationTrigger(a: string);
    private by;
    get dragRowID(): any;
    set dragRowID(a: any);
    private a5;
    get rowEditable(): boolean;
    set rowEditable(a: boolean);
    private bz;
    get rowHeight(): any;
    set rowHeight(a: any);
    private cn;
    get columnWidth(): string;
    set columnWidth(a: string);
    private cx;
    get emptyGridMessage(): string;
    set emptyGridMessage(a: string);
    private a0;
    get isLoading(): boolean;
    set isLoading(a: boolean);
    private a7;
    get shouldGenerate(): boolean;
    set shouldGenerate(a: boolean);
    private cu;
    get emptyFilteredGridMessage(): string;
    set emptyFilteredGridMessage(a: string);
    private aq;
    get pinning(): WebPinningConfigDescription;
    set pinning(a: WebPinningConfigDescription);
    private av;
    get allowFiltering(): boolean;
    set allowFiltering(a: boolean);
    private au;
    get allowAdvancedFiltering(): boolean;
    set allowAdvancedFiltering(a: boolean);
    private c6;
    get filterMode(): string;
    set filterMode(a: string);
    private em;
    get summaryPosition(): string;
    set summaryPosition(a: string);
    private el;
    get summaryCalculationMode(): string;
    set summaryCalculationMode(a: string);
    private a8;
    get showSummaryOnCollapse(): boolean;
    set showSummaryOnCollapse(a: boolean);
    private ag;
    get filterStrategy(): WebFilteringStrategyDescription;
    set filterStrategy(a: WebFilteringStrategyDescription);
    private am;
    get sortStrategy(): WebGridSortingStrategyDescription;
    set sortStrategy(a: WebGridSortingStrategyDescription);
    private as;
    get sortingOptions(): WebSortingOptionsDescription;
    set sortingOptions(a: WebSortingOptionsDescription);
    private ed;
    get selectedRowsRef(): string;
    set selectedRowsRef(a: string);
    private dd;
    get headSelectorTemplateRef(): string;
    set headSelectorTemplateRef(a: string);
    private d9;
    get rowSelectorTemplateRef(): string;
    set rowSelectorTemplateRef(a: string);
    private ct;
    get dragIndicatorIconTemplateRef(): string;
    set dragIndicatorIconTemplateRef(a: string);
    private q;
    get sortingExpressions(): WebSortingExpressionDescription[];
    set sortingExpressions(a: WebSortingExpressionDescription[]);
    private ax;
    get batchEditing(): boolean;
    set batchEditing(a: boolean);
    private ca;
    get cellSelection(): string;
    set cellSelection(a: string);
    private d7;
    get rowSelection(): string;
    set rowSelection(a: string);
    private cj;
    get columnSelection(): string;
    set columnSelection(a: string);
    private a1;
    get isPivot(): boolean;
    set isPivot(a: boolean);
    private ao;
    get outlet(): WebOverlayOutletDirectiveDescription;
    set outlet(a: WebOverlayOutletDirectiveDescription);
    private o;
    get columns(): WebColumnDescription[];
    set columns(a: WebColumnDescription[]);
    private bs;
    get totalRecords(): number;
    set totalRecords(a: number);
    private ay;
    get hasVisibleColumns(): boolean;
    set hasVisibleColumns(a: boolean);
    private a6;
    get selectRowOnClick(): boolean;
    set selectRowOnClick(a: boolean);
    private m;
    get actualColumns(): WebColumnDescription[];
    set actualColumns(a: WebColumnDescription[]);
    private c4;
    get filteringExpressionsTreeChangeRef(): string;
    set filteringExpressionsTreeChangeRef(a: string);
    private b4;
    get advancedFilteringExpressionsTreeChangeRef(): string;
    set advancedFilteringExpressionsTreeChangeRef(a: string);
    private da;
    get gridScrollRef(): string;
    set gridScrollRef(a: string);
    private dh;
    get pageChangeRef(): string;
    set pageChangeRef(a: string);
    private dk;
    get perPageChangeRef(): string;
    set perPageChangeRef(a: string);
    private b5;
    get cellClickRef(): string;
    set cellClickRef(a: string);
    private c7;
    get formGroupCreatedRef(): string;
    set formGroupCreatedRef(a: string);
    private eo;
    get validationStatusChangeRef(): string;
    set validationStatusChangeRef(a: string);
    private ec;
    get selectedRef(): string;
    set selectedRef(a: string);
    private d8;
    get rowSelectionChangingRef(): string;
    set rowSelectionChangingRef(a: string);
    private ck;
    get columnSelectionChangingRef(): string;
    set columnSelectionChangingRef(a: string);
    private cf;
    get columnPinRef(): string;
    set columnPinRef(a: string);
    private cg;
    get columnPinnedRef(): string;
    set columnPinnedRef(a: string);
    private b8;
    get cellEditEnterRef(): string;
    set cellEditEnterRef(a: string);
    private b9;
    get cellEditExitRef(): string;
    set cellEditExitRef(a: string);
    private b6;
    get cellEditRef(): string;
    set cellEditRef(a: string);
    private b7;
    get cellEditDoneRef(): string;
    set cellEditDoneRef(a: string);
    private d1;
    get rowEditEnterRef(): string;
    set rowEditEnterRef(a: string);
    private dy;
    get rowEditRef(): string;
    set rowEditRef(a: string);
    private d0;
    get rowEditDoneRef(): string;
    set rowEditDoneRef(a: string);
    private d2;
    get rowEditExitRef(): string;
    set rowEditExitRef(a: string);
    private cb;
    get columnInitRef(): string;
    set columnInitRef(a: string);
    private ci;
    get columnsAutogeneratedRef(): string;
    set columnsAutogeneratedRef(a: string);
    private ei;
    get sortingRef(): string;
    set sortingRef(a: string);
    private ej;
    get sortingDoneRef(): string;
    set sortingDoneRef(a: string);
    private c2;
    get filteringRef(): string;
    set filteringRef(a: string);
    private c3;
    get filteringDoneRef(): string;
    set filteringDoneRef(a: string);
    private di;
    get pagingDoneRef(): string;
    set pagingDoneRef(a: string);
    private dq;
    get rowAddedRef(): string;
    set rowAddedRef(a: string);
    private dv;
    get rowDeletedRef(): string;
    set rowDeletedRef(a: string);
    private du;
    get rowDeleteRef(): string;
    set rowDeleteRef(a: string);
    private dp;
    get rowAddRef(): string;
    set rowAddRef(a: string);
    private ch;
    get columnResizedRef(): string;
    set columnResizedRef(a: string);
    private co;
    get contextMenuRef(): string;
    set contextMenuRef(a: string);
    private cr;
    get doubleClickRef(): string;
    set doubleClickRef(a: string);
    private cm;
    get columnVisibilityChangingRef(): string;
    set columnVisibilityChangingRef(a: string);
    private cl;
    get columnVisibilityChangedRef(): string;
    set columnVisibilityChangedRef(a: string);
    private ce;
    get columnMovingStartRef(): string;
    set columnMovingStartRef(a: string);
    private cc;
    get columnMovingRef(): string;
    set columnMovingRef(a: string);
    private cd;
    get columnMovingEndRef(): string;
    set columnMovingEndRef(a: string);
    private c9;
    get gridKeydownRef(): string;
    set gridKeydownRef(a: string);
    private dx;
    get rowDragStartRef(): string;
    set rowDragStartRef(a: string);
    private dw;
    get rowDragEndRef(): string;
    set rowDragEndRef(a: string);
    private c8;
    get gridCopyRef(): string;
    set gridCopyRef(a: string);
    private eb;
    get rowToggleRef(): string;
    set rowToggleRef(a: string);
    private d6;
    get rowPinningRef(): string;
    set rowPinningRef(a: string);
    private d5;
    get rowPinnedRef(): string;
    set rowPinnedRef(a: string);
    private b2;
    get activeNodeChangeRef(): string;
    set activeNodeChangeRef(a: string);
    private ek;
    get sortingExpressionsChangeRef(): string;
    set sortingExpressionsChangeRef(a: string);
    private en;
    get toolbarExportingRef(): string;
    set toolbarExportingRef(a: string);
    private dm;
    get rangeSelectedRef(): string;
    set rangeSelectedRef(a: string);
    private dn;
    get renderedRef(): string;
    set renderedRef(a: string);
    private cq;
    get dataChangingRef(): string;
    set dataChangingRef(a: string);
    private cp;
    get dataChangedRef(): string;
    set dataChangedRef(a: string);
}
/**
 * @hidden
 */
export declare class WebGridToolbarDescription extends WebDisplayDensityBaseElementDescription {
    static $t: Type;
    protected get_type(): string;
    constructor();
    private q;
    get showProgress(): boolean;
    set showProgress(a: boolean);
    private o;
    get grid(): WebGridBaseDirectiveDescription;
    set grid(a: WebGridBaseDirectiveDescription);
    private s;
    get name(): string;
    set name(a: string);
    private m;
    get tools(): WebGridToolbarContentDescription[];
    set tools(a: WebGridToolbarContentDescription[]);
}
